# 
# Copyright (c) 2017, 2020, Oracle and/or its affiliates. All rights reserved.
#
# This software is dual-licensed to you under the MIT License (MIT) and the Universal Permissive License (UPL).  See the LICENSE file in the root directory for license terms.  You may choose
# either license, or both.
#

.print_openssl_src:
	@printf "Compile openssl source files...\n"

.clean_stored_folders:
	$(A)rm -rf $(OPENSSL)/lib/
	$(A)rm -rf $(OPENSSL)/include/

$(OPENSSL_LIBS): .clean_stored_folders $(OPENSSL)/$(OPENSSL_ARCH_FOLDER)/nmake.bat $(OPENSSL)/$(OPENSSL_ARCH_FOLDER)/unpacked
	$(A)mkdir -p $(dir $@)
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); ./nmake.bat /nologo
	$(A)cp -f $(OPENSSL)/$(OPENSSL_ARCH_FOLDER)/*.lib $(OPENSSL)/lib/
	$(A)cp -r -f $(OPENSSL)/$(OPENSSL_ARCH_FOLDER)/include/ $(OPENSSL)/include/

#	
$(OPENSSL)/$(OPENSSL_ARCH_FOLDER)/nmake.bat:
	$(A)mkdir -p $(dir $@)
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); echo "set MAKE=" >nmake.bat
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); echo "set MAKEFLAGS=" >>nmake.bat
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); echo "set DESTDIR=out32" >>nmake.bat
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); echo "perl.exe Configure VC-WIN32 no-asm" >>nmake.bat
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); echo "$(A)call \"$(VS150COMNTOOLS)\VsDevCmd.bat\"" >>nmake.bat
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); echo "$(A)call \"$(VS150COMNTOOLS)\..\..\VC\Auxiliary\Build\vcvars32.bat\"" >>nmake.bat
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); echo "$(A)nmake.exe %*" >>nmake.bat
	$(A)cd $(OPENSSL)/$(OPENSSL_ARCH_FOLDER); chmod +x nmake.bat

.windows_generate_tools_config:
	$(A)mkdir -p $(TMP_DIR)
	$(A)echo "$(A)call \"$(VS150COMNTOOLS)\VsDevCmd.bat\" & cl %*" >$(TMP_DIR)/cc.bat
	$(A)echo "$(A)call \"$(VS150COMNTOOLS)\VsDevCmd.bat\" & lib %*" >$(TMP_DIR)/ar.bat
	$(A)chmod +x $(TMP_DIR)/cc.bat $(TMP_DIR)/ar.bat

.windows_impl: .windows_generate_tools_config .print_openssl_src $(OPENSSL_LIBS)
	@printf "Openssl compilation finished!\n"
